const coral = @import("coral");

pub const Format = enum {
	rgba8,
	bgra8,

	pub fn byte_size(self: Format) usize {
		return switch (self) {
			.rgba8, .bgra8 => 4,
		};
	}
};

pub const Desc = struct {
	format: Format,
	access: Access,

	pub const Access = union (enum) {
		static: StaticAccess,
		render: RenderAccess,
	};

	pub const StaticAccess = struct {
		width: u16,
		data: []const coral.io.Byte,
	};

	pub const RenderAccess = struct {
		width: u16,
		height: u16,
	};
};

pub const Handle = enum (u32) {
	default,
	backbuffer,
	_,
};
